import getCrc from './getCrc';
import int32Mul from './int32Mul';

export default function getDecryptionKeys(password: Uint8Array) {
  const keys: [number, number, number] = [0x12345678, 0x23456789, 0x34567890];
  const passwordLength = password.length;

  //update keys
  for (let i = 0; i < passwordLength; i++) {
    if (password[i] === 0) { break; }
    keys[0] = getCrc(keys[0], password[i]);
    keys[1] =
        ((
            int32Mul((
                ((keys[1] >>> 0) + (keys[0] & 0xFF)) >>> 0
            ), 134775813) >>> 0
        ) + 1) >>> 0;
    keys[2] = getCrc(keys[2] >>> 0, keys[1] >>> 24);
  }

  return keys;
}
